/**
 * Consumer.java
 *
 * This is the consumer thread for the bounded buffer problem.
 *
 * @author Greg Gagne, Peter Galvin, Avi Silberschatz
 * @version 1.0 - July 15, 1999
 * Copyright 2000 by Greg Gagne, Peter Galvin, Avi Silberschatz
 * Applied Operating Systems Concepts - John Wiley and Sons, Inc.
 */

import java.util.*;

class Consumer extends Thread
{
   public Consumer(MessageQueue m)
   {
      mbox = m;
   }
   
   public void run()
   {
   Date message;
   
     while (true)
      {
         int sleeptime = (int) (Server.NAP_TIME * Math.random() );
 
         System.out.println("Consumer sleeping for " + sleeptime + " seconds");
 
         try { sleep(sleeptime*1000); } 
         catch(InterruptedException e) {}
         
         // consume an item from the buffer
         System.out.println("Consumer wants to consume.");
         
         message = (Date)mbox.receive();
         
         if (message != null)
            System.out.println("Consumer consumed " + message);
      }
   }
   
   private  MessageQueue mbox;
}
