/**
 * ClockApplet.java
 *
 * This applet displays the time of day. 
 * Note that this program uses deprecated methods,
 * an alternative version will be shown in chapter 8.
 *
 * @author Greg Gagne, Peter Galvin, Avi Silberschatz
 * @version 1.0 - July 15,  1999.
 * Copyright 2000 by Greg Gagne, Peter Galvin, Avi Silberschatz
 * Applied Operating Systems Concepts - John Wiley and Sons, Inc.
 */
 
import java.applet.*;
import java.awt.*;

public class ClockApplet extends Applet implements Runnable
{
   public void run() {
      while (true) {
         try {
            Thread.sleep(1000);
         }
         catch (InterruptedException e) {}
         
         repaint();
      }
   }
   
   // this method is called when the applet is started or
   // we return to the applet
   public void start() {
      if ( clockThread == null ) {
         clockThread = new Thread(this);
         clockThread.start();
      }
      else
         clockThread.resume();
   }
   
   // this method is called when we leave the page the applet is on
   public void stop() {
      if (clockThread != null)
         clockThread.suspend();
   }
   
   // this method is called when the applet is removed from the cache
   public void destroy() {
      if (clockThread != null) {
         clockThread.stop();
         
         clockThread = null;
      }
   }
 
   public void paint(Graphics g) {
      g.drawString( new java.util.Date().toString(), 10, 30);
   }
   
   private Thread clockThread;
}
