/**
 * Algorithm_1.java
 *
 * This program implements strict alternation as a means of handling synchronization.
 * This solution corresponds to Algorithm 1
 *
 * @author Greg Gagne, Peter Galvin, Avi Silberschatz
 * @version 1.0 - July 15, 1999
 * Copyright 2000 by Greg Gagne, Peter Galvin, Avi Silberschatz
 * Applied Operating Systems Concepts - John Wiley and Sons, Inc.
 */

 
 public class Algorithm_1 extends MutualExclusion
 {
   public Algorithm_1() {
      turn = TURN_0;
   }
  
   public void enteringCriticalSection(int t) {
	while (turn != t)
		Thread.yield(); 
   }

   public void leavingCriticalSection(int t) {
	turn = 1 - t;
   }
 
   private volatile int turn;
}
