/**
 * ClockApplet.java
 *
 * This applet displays the time of day.
 * Note that this program is a rewrite of the version from chapter 5.
 * The chapter 5 version contained deprecated methods suspend() and
 * resume(). This version accomplishes the same as shown in chapter 5,
 * but without using the deprecated methods.
 *
 * The calls to System.out.println() are purely for debugging - use
 * the Java console with your browser to see these output statements.
 *
 * @author Greg Gagne, Peter Galvin, Avi Silberschatz
 * @version 1.0 - July 15,  1999.
 * Copyright 2000 by Greg Gagne, Peter Galvin, Avi Silberschatz
 * Applied Operating Systems Concepts - John Wiley and Sons, Inc.
 */
 
import java.applet.*;
import java.awt.*;

public class ClockApplet extends Applet implements Runnable
{
   public void run() {
      Thread me = Thread.currentThread();
      
      while (clockThread == me) {
         try {
            Thread.sleep(1000);
        
            repaint();
         
            synchronized (mutex) {
               while (ok == false)
                     mutex.wait();
            }
         }
         catch (InterruptedException e) { }
      }
      System.out.println("terminating thread");
   }
   
   // this method is called when the applet is 
   // started or we return to the applet
   public void start() {
      if ( clockThread == null ) {
         System.out.println("creating thread");
         ok = true;
         clockThread = new Thread(this);
         clockThread.start();
      }
      else {
         System.out.println("resuming thread");
         synchronized(mutex) {
            ok = true;
            mutex.notify();
         }
      }
   }
   
   // this method is called when we
   // leave the page the applet is on
   public void stop() {
      if (clockThread != null) {
         System.out.println("suspending thread");
         synchronized(mutex) {
            ok = false;
         }
         clockThread = null;
      }
   }
   
   // this method is called when the applet is removed from the cache
   public void destroy() {
         clockThread = null;
   }
 
   public void paint(Graphics g) {
      g.drawString( new java.util.Date().toString(), 10, 30);
      System.out.println( new java.util.Date().toString());
   }
   
   private volatile Thread clockThread;
   private boolean ok = false;
   Object mutex = new Object();
}



